/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.math.BigInteger;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.TGENEMODULEDESC")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Tgenemoduledesc.findAll", query = "SELECT t FROM Tgenemoduledesc t"),
    @NamedQuery(name = "Tgenemoduledesc.findByModulecode", query = "SELECT t FROM Tgenemoduledesc t WHERE t.tgenemoduledescPK.modulecode = :modulecode"),
    @NamedQuery(name = "Tgenemoduledesc.findByLanguagecode", query = "SELECT t FROM Tgenemoduledesc t WHERE t.tgenemoduledescPK.languagecode = :languagecode"),
    @NamedQuery(name = "Tgenemoduledesc.findByRecordversion", query = "SELECT t FROM Tgenemoduledesc t WHERE t.recordversion = :recordversion"),
    @NamedQuery(name = "Tgenemoduledesc.findByDescription", query = "SELECT t FROM Tgenemoduledesc t WHERE t.description = :description")})
public class Tgenemoduledesc implements Serializable {

    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected TgenemoduledescPK tgenemoduledescPK;
    @Column(name = "RECORDVERSION")
    private BigInteger recordversion;
    @Column(name = "DESCRIPTION")
    private String description;
    @JoinColumn(name = "LANGUAGECODE", referencedColumnName = "LANGUAGECODE", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Tgenelanguage tgenelanguage;
    @JoinColumn(name = "MODULECODE", referencedColumnName = "MODULECODE", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Tgenemodule tgenemodule;

    public Tgenemoduledesc() {
    }

    public Tgenemoduledesc(TgenemoduledescPK tgenemoduledescPK) {
        this.tgenemoduledescPK = tgenemoduledescPK;
    }

    public Tgenemoduledesc(String modulecode, String languagecode) {
        this.tgenemoduledescPK = new TgenemoduledescPK(modulecode, languagecode);
    }

    public TgenemoduledescPK getTgenemoduledescPK() {
        return tgenemoduledescPK;
    }

    public void setTgenemoduledescPK(TgenemoduledescPK tgenemoduledescPK) {
        this.tgenemoduledescPK = tgenemoduledescPK;
    }

    public BigInteger getRecordversion() {
        return recordversion;
    }

    public void setRecordversion(BigInteger recordversion) {
        this.recordversion = recordversion;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Tgenelanguage getTgenelanguage() {
        return tgenelanguage;
    }

    public void setTgenelanguage(Tgenelanguage tgenelanguage) {
        this.tgenelanguage = tgenelanguage;
    }

    public Tgenemodule getTgenemodule() {
        return tgenemodule;
    }

    public void setTgenemodule(Tgenemodule tgenemodule) {
        this.tgenemodule = tgenemodule;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tgenemoduledescPK != null ? tgenemoduledescPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tgenemoduledesc)) {
            return false;
        }
        Tgenemoduledesc other = (Tgenemoduledesc) object;
        if ((this.tgenemoduledescPK == null && other.tgenemoduledescPK != null) || (this.tgenemoduledescPK != null && !this.tgenemoduledescPK.equals(other.tgenemoduledescPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.Tgenemoduledesc[ tgenemoduledescPK=" + tgenemoduledescPK + " ]";
    }
    
}
